#define STATE_LN 0x1f

__no_init
struct
{
 u8 state[STATE_LN];

 u8 ee_code[2][DBUF_SIZE];
} eep @ 0x4005;


void pop_u8(u8 *data, u8 mss[], u8 mss_ln = STATE_LN)
{
 *data = 0xff;

 for(u8 i=0;i<mss_ln;i++)
 {
  if(mss[i]!=0xff)
  {
   *data = mss[i];

   break;
  }
 }
}

void push_u8(const u8 data, u8 mss[], u8 mss_ln = STATE_LN)
{
 u8 tmp;

 pop_u8(&tmp, mss);

 if(tmp != data)
 {
  bool trg=0;

  FLASH_Unlock(FLASH_MEMTYPE_DATA);

  //       0xff
  for(u8 i=0;i<mss_ln;i++)
  {
   if(mss[i]!=0xff)
   {
    if(i < mss_ln-1) mss[i+1] = data;
    else             mss[0]   = data;

    mss[i]   = 0xff;
    trg = 1;

    break;
   }
  }

  if(!trg) mss[0] = data;

  FLASH_Lock(FLASH_MEMTYPE_DATA);
 }
}

bool check_ee_code(void) //     true
{
 for(u8 i=0;i<DBUF_SIZE;i++)
 {
  u8 g1 = eep.ee_code[0][i] ;
  u8 g2 = ~eep.ee_code[1][i];
  if(g1!=g2) return false;
 }
 return true;
}

void ee_init(bool ne_trg = 0)
{
 //        
 // 

 ne_trg = !check_ee_code();

 //    
 if(ne_trg)
 {
  FLASH_Unlock(FLASH_MEMTYPE_DATA);
  for(u8 i=0;i<DBUF_SIZE;i++)
  {
   eep.ee_code[0][i]=0;
   eep.ee_code[1][i]=0xff;
  }
  FLASH_Lock(FLASH_MEMTYPE_DATA);

  push_u8(0, eep.state);
 }
}

void fill_rbuf_from_ee(void)
{
 for(u8 i=0;i<DBUF_SIZE-1;i++)
 {
  u8 g1 = eep.ee_code[0][i] ;
  ref_buff[i]=(oprt)g1;
 }

 ref_buff[DBUF_SIZE-1] = OP_NULL;
}

void save_code(const oprt buff[], u8 size = DBUF_SIZE)
{
 FLASH_Unlock(FLASH_MEMTYPE_DATA);
 for(u8 i=0;i<size;i++)
 {
  eep.ee_code[0][i] = (u8)buff[i];
  eep.ee_code[1][i] = ~(u8)buff[i];
 }
 FLASH_Lock(FLASH_MEMTYPE_DATA);
}

bool check_ee_ram_code(void)
{
 for(u8 i=0;i<DBUF_SIZE-1;i++)
 {
  //     
  if(ref_buff[i]!=eep.ee_code[0][i]) return false;
 }
 return true;
}