#include <kb.h>

void init_kb_pins(GDF *GPIO_cols, GDF *GPIO_rows)
{
 u8 kl;

 for(u8 i=0;i<ROWS;i++)
 {
  kl = (u8)(GPIO_rows+i)->GPIO_Pin;

  (GPIO_rows+i)->GPIOx->ODR &= ~kl;
 }

 for(u8 i=0;i<COLS;i++)
 {
  kl = (u8)(GPIO_cols+i)->GPIO_Pin;

  (GPIO_cols+i)->GPIOx->ODR &= ~kl;
  (GPIO_cols+i)->GPIOx->CR1 |= kl;
 }
}

void init_btn_pin (GDF *pin)
{
 u8 kl = (u8)pin->GPIO_Pin;

 pin->GPIOx->DDR &= ~kl;
 pin->GPIOx->CR1 |= kl;
}

u8 scan_keys(GDF *GPIO_cols, GDF *GPIO_rows, keyst btn[])
{
 static u8 column;
 static u8 count[COLS*ROWS][3];
 bool key_st[ROWS];
 u8 i;
 keyst btn_tmp;
 u8 chb_pos = 0xff;

 static bool trg=0;
 if(!trg)
 {
  init_kb_pins(GPIO_cols, GPIO_rows);
  init_btn_pin(&GPIO_btn);
  trg = 1;
 }


 //          
 for(i=0;i<ROWS;i++)
 {
  GDF *gpt = GPIO_rows+i;
  u8 kl = (u8)gpt->GPIO_Pin;

  //    
  gpt->GPIOx->DDR &= ~kl;

  //   
  gpt->GPIOx->CR1 |= kl;

  //         
  key_st[i] = !!(gpt->GPIOx->IDR & kl);

  //    
  gpt->GPIOx->CR1 &= ~kl;

  //        
  gpt->GPIOx->DDR |= kl;


  u8 pos = column+i*COLS;

  //        
  btn_tmp = btn[pos];

  read_key(key_st+i, count, btn, pos);

  //  
  if(btn_tmp != btn[pos] && btn[pos]==prs)
  {
   //  
   chb_pos = pos;
  }
 }

 //       
 //          
 (GPIO_cols+column)->GPIOx->DDR &= ~(u8)(GPIO_cols+column)->GPIO_Pin;

 if(column <COLS-1) column ++;
 else column = 0;

 //           
 (GPIO_cols+column)->GPIOx->DDR |= (u8)(GPIO_cols+column)->GPIO_Pin;

 //      ,   0xff;
 return chb_pos;
}

void key_2_ops(u8 n_b, oprt *ops)
{
 switch (n_b)
 {
  case 0 : {*ops = OP_ENT;}break;
  case 1 : {*ops = OP_7;}break;
  case 2 : {*ops = OP_8;}break;
  case 3 : {*ops = OP_9;}break;
  case 4 : {*ops = OP_BSP;}break;
  case 5 : {*ops = OP_4;}break;
  case 6 : {*ops = OP_5;}break;
  case 7 : {*ops = OP_6;}break;
  case 8 : {*ops = OP_0;}break;
  case 9 : {*ops = OP_1;}break;
  case 10: {*ops = OP_2;}break;
  case 11: {*ops = OP_3;}break;
  default: {*ops = OP_NULL;}break;
 }
}

void dops_2_dbuf(const oprt ops, oprt data_buffer[], u8 b_size = DBUF_SIZE)
{
 for(u8 i=b_size-2;i;i--)data_buffer[i] = data_buffer[i-1];

 data_buffer[0] = ops;
}

void cops_2_cbuf (const oprt ops, oprt command_buffer[], u8 b_size = CBUF_SIZE)
{
 for(u8 k=b_size-1;k;k--)command_buffer[k] = command_buffer[k-1];

 command_buffer[0] = ops;
}

//,      
void cops_dops (const oprt ops, oprt command_buffer[], oprt data_buffer[])
{
 if(ops < OP_ENT) dops_2_dbuf(ops, data_buffer);
 else             cops_2_cbuf(ops, command_buffer);
}

void clear_data_buffer (oprt data_buffer[], u8 size = DBUF_SIZE)
{
 for(u8 i=0;i<size;i++) data_buffer[i]=OP_NULL;
}

void clear_command_buffer (void)
{
 for(u8 i=0;i<sizeof(command_buffer)/sizeof(oprt);i++) command_buffer[i]=OP_NULL;
}

void bsp_data_buffer(oprt data_buffer[], u8 size = DBUF_SIZE)
{
 for(u8 i=0;i<size;i++)data_buffer[i] = data_buffer[i+1];

 data_buffer[size-1] = OP_NULL;
}

void read_key(bool key_st[], u8 count[][3], keyst btn[], const u8 pos)
{
 //   
 if (!(*key_st)) //     
 {
  if(count[pos][0]>lp)
  {
   count[pos][0]=0;

   if(btn[pos]==rls) btn[pos]=prs;

   if(count[pos][1]>lh)
   {
    btn[pos]=hold;
    count[pos][1]=0;
   }
   else
    count[pos][1]++;
  }
  else
   count[pos][0]++;

  count[pos][2]=lr;
 }
 else //   ,       
 {
  if(count[pos][2])
   count[pos][2]--;
  else
  {
   count[pos][0]=0;
   count[pos][1]=0;

   btn[pos]=rls;
  }
 }
}

bool read_btn(void)
{
 static keyst btn0 = rls;
 static u8 count[1][3];

 volatile bool key_st = !!(GPIO_btn.GPIOx->IDR & (u8)GPIO_btn.GPIO_Pin);
 bool tmp = key_st;

 keyst btn_tmp = btn0;
 read_key(&tmp, count, &btn0, 0);

 if(btn_tmp!=btn0 && btn0==prs) return true;

 return false;
}