/********************************************************
Workspace: IAR+SPL
MCU      : STM8S003K3
Project  : code_lock
Version  : 0
Date     : Feb 2019
*********************************************************/
#include <stdbool.h>
#include <string.h>

#include "stm8s.h"
#include "iostm003.c"
#include "bitset.c"
#include "defines.c"
#include "periph_init.c"
#include "kb.c"
#include "m_control.c"
#include "crc16.c"
#include "keylock.c"
#include "ee_works.c"


volatile u16 tim0,tim1,tim2;
volatile bool kbs_trg; //  
volatile bool iwdg_trg;

bool r_led_tmp;
bool g_led_tmp;
bool led_trg=0;

bool r_led_trg;
bool g_led_trg;

extern "C"
{
 INTERRUPT_HANDLER(EXTI_C, 5)
 {


 }

 INTERRUPT_HANDLER(TIM4_OVF, 23)   //1000Hz
 {
  if(tim0)tim0--;
  if(tim1)tim1--;
  if(tim2)tim2--;

  kbs_trg=1;

  iwdg_trg = 1;
  TIM4->SR1 = 0;
 }
}

bool devcon(bool&);

void main()
{
 cfg.gpio();
 cfg.clk();
 cfg.t4();
 ee_init();
 cfg.iwdg();

 asm("rim");
 endless
 {
  static bool devcon_trg  = true;
  static bool btn_prs_trg;

  //     
  if(kbs_trg)
  {
   kbs_trg=0;

   //  
   u8 tmp = scan_keys(GPIO_cols, GPIO_rows, btn);
   //  
   btn_prs_trg = read_btn();

   //   
   if(tmp != 0xff)
   {
    //  ,        
    if(btn[tmp]==prs)
    {
     oprt ops;
     key_2_ops(tmp, &ops);
     cops_dops (ops, command_buffer, data_buffer);

     devcon_trg=1;
    }
   }
  }

  //    1
  if(!tim1)
  {
   //     
   if(led_trg)
   {
    LED_G = g_led_tmp;
    LED_R = r_led_tmp;

    led_trg = 0;
   }
   //   
   else if(g_led_trg || r_led_trg)
   {
    tim1 = 400;

    if(g_led_trg) LED_G ^=1; else LED_G = LOFF;
    if(r_led_trg) LED_R ^=1; else LED_R = LOFF;
   }
  }


  if(devcon_trg || btn_prs_trg) devcon_trg = devcon(btn_prs_trg);
  else wfi();

  if(iwdg_trg){iwdg_trg = 0; IWDG_ReloadCounter();}
 }
}

bool devcon(bool &btn_prs)
{
 static bool devcon_trg;
 static bool itr=0;
 static enum {start,unlock,unlocked,lock,locked,setup,err}dev_st = start;

 if(btn_prs==true)
 {
  btn_prs = false;

  if(dev_st!= setup)
  {
   if(dev_st!=unlock && dev_st!=unlocked)  dev_st = unlock;
   else if(dev_st!=lock && dev_st!=locked) dev_st = lock;
   itr = 0;
  }
 }

 switch (dev_st)
 {
  case start:
  {
   if(!itr)
   {
    itr=1;
    devcon_trg = 1;

    LED_R = LON;
    LED_G = LON;

    CLK->CKDIVR = 0;
    if(TestFlash()==false) dev_st = err;
    CLK->CKDIVR = 0x18;

    clear_command_buffer();

    if(check_ee_code()==true)
    {
     fill_rbuf_from_ee();

     u8 lock_state;
     pop_u8(&lock_state, eep.state);

     if(!lock_state) dev_st = unlock;
     else            dev_st = lock;
    }
    //    prom 
    else dev_st = unlock;
   }

   LED_R = LOFF;
   LED_G = LOFF;

   if(dev_st!=start){itr=0;}
  }
  break;

  case unlock:
  {
   if(!itr)
   {
    itr=1;
    devcon_trg = 1;

    LED_R = LON; //       ,   ,  
    tim0 = 0;
   }

   if(m_unlock()==true)
   {
    dev_st = unlocked;
    LED_R = LOFF;
    LED_G = LON;
   }
   else
   {
    if(!tim0)
    {
     tim0 = 300;
     LED_G ^= 1;
    }
   }

   if(dev_st!=unlock){itr=0;}
  }
  break;

  case unlocked:
  {
   if(!itr)
   {
    itr=1;

    clear_data_buffer(data_buffer);
    clear_command_buffer();

    g_led_tmp = LED_G;
    r_led_tmp = LED_R;

    u8 lock_state;
    pop_u8(&lock_state, eep.state);
    if(lock_state)push_u8(0, eep.state);
   }
   else
   {
    if(command_buffer[0]==OP_ENT)
    if(command_buffer[1]==OP_ENT)
    {
     dev_st = lock;
    }

    if(command_buffer[0]==OP_ENT)
    if(command_buffer[1]==OP_BSP)
    if(command_buffer[2]==OP_ENT)
    if(command_buffer[3]==OP_BSP)
    {
     dev_st = setup;
    }
   }

   if(dev_st!=unlocked){itr=0; devcon_trg = 1;}
   else
   {
    devcon_trg = 0;
    //      
    LED_G = LOFF;
    tim1 = 200;
    led_trg = 1;
   }
  }
  break;

  case lock:
  {
   if(!itr)
   {
    itr=1;
    devcon_trg = 1;

    LED_G = LON;
    tim0 = 0;
   }

   if(m_lock()==true)
   {
    dev_st = locked;
    LED_G = LOFF;
    LED_R = LON;
   }
   else
   {
    if(!tim0)
    {
     tim0 = 300;
     LED_R ^= 1;
    }
   }

   if(dev_st!=lock){itr=0;}
  }
  break;

  case locked:
  {
   if(!itr)
   {
    itr=1;
    clear_data_buffer(data_buffer);
    clear_command_buffer();

    g_led_tmp = LED_G;
    r_led_tmp = LED_R;

    u8 lock_state;
    pop_u8(&lock_state, eep.state);
    if(!lock_state)push_u8(1, eep.state);
   }
   else
   {
    if(command_buffer[0]==OP_ENT)
    {
     //        
     if(check_buff_coincidence()== true) dev_st = unlock;
     //   eeprom     
     if(check_ee_code()         == false) dev_st = err;
     //         eeprom
     if(check_ee_ram_code()== false)
     {
      //   eeprom  ram
      fill_rbuf_from_ee();
      //   - 
      if(check_ee_ram_code()== false) dev_st = err;
     }

     clear_data_buffer(data_buffer);
     clear_command_buffer();
    }
    else if(command_buffer[0]==OP_BSP)
    {
     bsp_data_buffer(data_buffer);
     clear_command_buffer();
    }
   }

   if(dev_st!=locked){itr=0; devcon_trg = 1;}
   else
   {
    devcon_trg = 0;
    //      
    LED_R = LOFF;
    tim1 = 200;
    led_trg = 1;
   }
  }
  break;

  case err:
  {
   if(!itr)
   {
    itr=1;

    u8 lock_state;
    pop_u8(&lock_state, eep.state);
    if(lock_state)push_u8(0, eep.state);

    LED_R = LOFF;
    LED_G = LON;

    g_led_trg = 1;
    r_led_trg = 1;
    devcon_trg = 1;
   }

   static bool trg=false;

   if(trg==false) trg=m_unlock();
   else devcon_trg=0;

   if(dev_st!=err){itr=0;}
  }
  break;

  case setup:
  {
   static enum {key0, key1}ken_stage;

   if(!itr)
   {
    itr=1;
    devcon_trg = 0;
    LED_G = LOFF;
    LED_R = LOFF;

    clear_data_buffer(data_buffer);
    clear_data_buffer(ref_buff);
    clear_command_buffer();

    led_trg   = 0;
    g_led_trg = 1;
    r_led_trg = 0;
    ken_stage = key0;
   }
   else
   {
    if(command_buffer[0]==OP_BSP) bsp_data_buffer(data_buffer);
    else if(command_buffer[0]==OP_ENT)
    {
     //  enter     
     if(ken_stage==key0)
     {
      strncpy((char*)ref_buff,(char*)data_buffer,DBUF_SIZE);
      clear_data_buffer(data_buffer);

      g_led_trg = 0;
      r_led_trg = 1;
      ken_stage = key1;
     }
     else
     {
      //       
      if(strncmp((char*)ref_buff, (char*)data_buffer,DBUF_SIZE)==0)
      {
       //   prom      
       fill_rbuf_from_ee();
       //   eeprom     
       if(strncmp((char*)ref_buff, (char*)data_buffer,DBUF_SIZE)!=0)
       {
        //   eeprom
        save_code(data_buffer);

        //   
        fill_rbuf_from_ee();

        if(strncmp((char*)ref_buff, (char*)data_buffer,DBUF_SIZE)==0)
        {
         dev_st = start;
        }
        else dev_st = err;
       }
       else dev_st = start;

       r_led_trg = 0;
      }
      //  ,  
      else
      {
       itr=0;
       devcon_trg=1;
      }
     }
    }
    else devcon_trg = 0;

    clear_command_buffer();
   }

   if(dev_st!=setup)
   {
    itr=0;
    devcon_trg = 1;

    LED_G = LOFF;
    LED_R = LOFF;
   }
  }
  break;
 }

 return devcon_trg;
}